/**
 * UserCode:HoloLens Controller 0.1
 *
 * sakitune <http://solica.net>
**/
var EventDevice = {
    None: 0,
    Left: 1,
    Right: 2,
    LeftRight: 4,
    Touch1: 8,
    Touch2: 16,
    Touch3: 32,
    Wheel: 64,
    Default: 1 | 8, //Left | Touch1
};
var EventType = {
    None: 0,
    Hover: 1,//Begin Run End
    Down: 2,//Begin End
    Drag: 3,// Standby Begin Run End
    Flick: 4,// End
    Click: 5,// Standby End
    DblClick: 6,// End
    Wheel: 7,//End
    Pinch: 8,//Begin Run End
    Hold: 9,//Begin End
}
var EventStatus = {
    Standby: 0,
    Begin: 1,
    Run: 2,
    End: 3,
}
/*
export class EventParams {
	public get Element(): HTMLElement{
	    return this.Root.EventElement;
	}
	public Root: RootEventPanel;
	public Event: any;
	public Time: number;
	public Panel: EventPanel;
	public StartPoint: Point;
	public NowPoint: Point;
	public Touchs: TouchList;
	public Device: EventDevice;
	public IsHold: boolean = false;
	public IsDrag: boolean = false;
	public EStatus: EventStatus;
	public EType: EventType;
	public Pinch: number = -1;
	public StartPinch: number = -1;
	public PointLogs: PointLog[];
	public Delta: number;
	public DeltaX: number;
	public DeltaY: number;
	public VX: number;
	public VY: number;
	public Tag: any;
}
*/
// 簡易API呼び出しリファレンス
/*
var rest = new AnalogWebbRest; //定義済み
 KeyCode入力 
 ※Virtual Inputでは'stroke'が発生しないようなので未確認
 function sendKeyboardKeyCode(code, state)
  code:文字コード
  state:'up' or 'stroke' or 'down'

文字入力 
 ※ Virtual keyboardでは文字をこちらで送っている
 function sendKeyboardKeyText(text)
  text: 文字

 スクロール APIはあるが現在動作しない？
 rest.sendScrollUpdate(velocityx,velocityy);

 タッチ  APIはあるが現在動作しない？
 rest.sendGestureInput(param);
 param: "press" or "release" or "pressrelease"
*/

// ClickとDblClickは別のものとして扱われDblClickの発生にClickを経由しません。
// その為ダブルクリックが有効である場合クリックが確定するのに時間がかかります
function userInit() {
    inputEvent.IsDblClickEvent = false;
    $("#LogArea").hide();
}
// holographic.rest.js

//
//*****************************************必要に応じて以下を修正してください*****************************************
//
var keyrepeatIntaval = 100;
var intervalid = 0;
var prevPoint;
function userEvent(param) {
    // Device(param.Device):マウス入力(Left Right Left&Right)やマウスホイール、タッチ時の指の本数が指定できます。
    // EventType(param.EType):クリックやドラッグなどのイベントが指定できます
    // Status(param.EStatus):イベントはStandby→Begin→Run→Endで状態遷移します。イベントにより発生しないStatusがあります。
    //                       Dragは短い距離では発生せずStandbyのままで明確に移動とみなされたときにBeginに状態遷移します。
    var key = 0;
    //左クリックかタッチ1
    if (param.Device & EventDevice.Default) {
        switch (param.EType) {
            case EventType.Drag:
                switch (param.EStatus) {
                    case EventStatus.Begin:
                        var vec = { x: param.NowPoint.x - param.StartPoint.x, y: param.NowPoint.y - param.StartPoint.y };
//                        $("#LogArea").val(Math.round(vec.x) + "," + Math.round(vec.y) + "\r\n" + $("#LogArea").val());
                        if (Math.abs(vec.x) > Math.abs(vec.y)) {
                            if (vec.x < 0) {
                                key = 37; // ←
                            } else {
                                key = 39; // →
                            }
                        } else {
                            if (vec.y < 0) {
                                key = 38; // ↑
                            } else {
                                key = 40; // ↓
                            }
                        }
                        intervalid = setInterval(function () {
                            sendKeyboardKeyCode(key, "down");
                            sendKeyboardKeyCode(key, "up");
                        }, keyrepeatIntaval);
                        break;
                    case EventStatus.End:
                        clearInterval(intervalid);
                        break;
                }
                break;
            case EventType.Click:
                break;
        }
    }
    if (param.Device & EventDevice.Touch2) {
        switch (param.EType) {
            case EventType.Drag:
                switch (param.EStatus) {
                    case EventStatus.Begin:
                        var vec = { x: param.NowPoint.x - param.StartPoint.x, y: param.NowPoint.y - param.StartPoint.y };
                        if (Math.abs(vec.x) > Math.abs(vec.y)) {
                            //Ctrl+ A
                            sendKeyboardKeyCode(17, "down");
                            sendKeyboardKeyCode(65, "down");
                            sendKeyboardKeyCode(17, "up");
                            sendKeyboardKeyCode(65, "up");
                            sendKeyboardKeyCode(46, "down");
                            sendKeyboardKeyCode(46, "up");
                        } else {
                            if (vec.y < 0) {
                                key = 36; // ↑ Home
                            } else {
                                key = 35; // ↓ End
                            }
                            sendKeyboardKeyCode(key, "down");
                            sendKeyboardKeyCode(key, "up");
                        }
                        break;
                    case EventStatus.End:
                        break;
                }
                break;
            case EventType.Click:
                break;
        }
    }
    if (param.Device & EventDevice.Touch3) {
        switch (param.EType) {
            case EventType.Drag:
                switch (param.EStatus) {
                    case EventStatus.Begin:
                        var vec = { x: param.NowPoint.x - param.StartPoint.x, y: param.NowPoint.y - param.StartPoint.y };
                        key = 0;
                        if (Math.abs(vec.x) > Math.abs(vec.y)) {
                            if (vec.x < 0) {
                            } else {
                            }
                        } else {
                            if (vec.y < 0) {
                            } else {
                                key = 91; // Windows↓
                            }
                        }
                        if (key != 0) {
                            sendKeyboardKeyCode(key, "down");
                            sendKeyboardKeyCode(key, "up");
                        }
                        break;
                    case EventStatus.End:
                        break;
                }
                break;
            case EventType.Click:
                break;
        }
    }
    /* スクロール動かず
    //タッチ2 スクロールに割り当ててみる
	if (param.Device & EventDevice.Touch2 ) {
	    switch (param.EType) {
	        case EventType.Drag:
	            switch (param.EStatus) {
	                case EventStatus.Begin:
	                    prevPoint = param.NowPoint;
	                    break;
                    case EventStatus.Run:
                        var vec = { x: param.NowPoint.x - prevPoint.x, y: param.NowPoint.y - prevPoint.y };
                        sendScroll(vec.x, vec.y);
                        prevPoint = param.NowPoint;
                        break;
	                case EventStatus.End:
	                    break;
	            }
	            break;
	    }
	}
    // ホイール
	if (param.Device & EventDevice.Wheel) {
	    switch (param.EType) {
	        case EventType.Wheel:
	            switch (param.EStatus) {
	                case EventStatus.End:
	                    sendScroll(param.DeltaY * 16, param.DeltaX * 16);
	                    break;
	            }
	            break;
	    }
	}
    */

}
